Subject: Re: bug#19080: 24.4; wish: enable show-paren-mode to highlight matching same-level keywords

From: Josh Berdine <[email-masked]>
Date: Fri, 13 May 2022 12:48:25 +0100

>> I think, that adding tree-sitter “backend” needs refactoring existing code non-trivially.
> 
> If show-paren-mode would want to use tree-sitter, it will need
> refactoring, yes.  Which other packages you envision could benefit
> from using tree-sitter?

For some context, this originally came up in discussion of
https://github.com/ocaml/tuareg/issues/26 and the related https://debbugs.gnu.org/cgi/bugreport.cgi?bug=19079 . This issue is about incorrect highlighting due to an smie bug, which tuareg-mode uses. As far as I understand, the incorrect highlighting prevents implementing navigation functions e.g. from a `let` to the matching `in`. I expect that tree-sitter can have a better understanding of the actual code structure than smie, and so tuareg-mode would be a package that could benefit. There is an ocaml (the language tuareg-mode supports) grammar for tree-sitter. I don't have the expertise to volunteer to work on that though.